const mqtt = require('mqtt')
const client = mqtt.connect('mqtt://localhost')
const libSupport = require('../dispatcher/lib')
const execute = require('./execute')
const node_id = "20sez54hq8"

client.on('connect', function () {
    client.subscribe(node_id, function (err) {
        if (!err) {
            console.log("node listening to id", node_id);
            
        }
    })
})

client.on('message', function (topic, message) {
    // message is Buffer
    
    message = JSON.parse(message)
    if (message.type !== 'heartbeat')
        console.log(message.toString())
    let runtime = message.runtime
    let functionHash = message.functionHash

    if (message.type === "execute") {
        if (runtime === "isolate")
            execute.runIsolate('../dispatcher/test/' + functionHash).then(() => client.publish(node_id, JSON.stringify({ status: "success" })))
        else if (runtime === "process")
            execute.runProcess('../dispatcher/test/' + functionHash).then(() => client.publish(node_id, JSON.stringify({ status: "success" })))
        else if (runtime === "container")
            execute.runContainer(functionHash).then(() => client.publish(node_id, JSON.stringify({ status: "success" })))
        else {
            client.publish(node_id, JSON.stringify({ status: "unknown runtime" }))
            return
        }
    }
    
})

function heartbeat() {
    client.publish(node_id, JSON.stringify({"type": "heartbeat"}))
}

setInterval(heartbeat, 10000);